/*
 * nasd_vx_incstat.c
 *
 * Increment nasd statistic word under VxWorks
 */
/*
 * Copyright (c) 1996,1997,1998,1999 Carnegie-Mellon University.
 * All rights reserved.
 *
 * Author: Marc Unangst
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon the
 * rights to redistribute these changes.
 */

#include <taskLib.h>

#include <nasd/nasd_options.h>
#include <nasd/nasd_types.h>

/* Atomically increment a 64-bit word. */
void
nasd_atomic_inc64(nasd_int64 i)
{
  /* might need intLock()/intUnlock() here -- how atomic do you want to be? */
  taskLock();
  i++;
  taskUnlock();
}

/* Atomically increment a 32-bit word. */
void
nasd_atomic_inc32(nasd_int32 i)
{
  taskLock();
  i++;
  taskUnlock();
}
