/*
 * nasd_dux_drive.h
 *
 * Digital Unix specific drive code
 */
/*
 * Copyright (c) 1997,1998,1999 Carnegie-Mellon University.
 * All rights reserved.
 *
 * Author: Jim Zelenka
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon the
 * rights to redistribute these changes.
 */

#ifndef _NASD__NASD_GENERIC_DRIVE_H_
#define _NASD__NASD_GENERIC_DRIVE_H_

/*
 * !!! This must be <= UIO_MAXIOV
 *
 * Erik's numbers suggest that 8 is an optimal value here
 * (that means that we try to achieve 64k I/Os).
 */
#define NASD_IO_MAX_COALESCE 8

#define nasd_odc_io_ent_swap_bufs(_ent1_,_ent2_) { \
  void  *_tmp_buf; \
  _tmp_buf = (_ent1_)->data.buf; \
  (_ent1_)->data.buf = (_ent2_)->data.buf; \
  (_ent2_)->data.buf = _tmp_buf; \
}

#define NASD_ODC_IO_ENT_CLEAR_PAGE(_ent_) { \
  (_ent_)->data.buf = NULL; \
}

#define NASD_ODC_IO_ENT_ASSERT_NO_PAGE(_ent_) { \
  NASD_ASSERT((_ent_)->data.buf == NULL); \
}

extern nasd_status_t nasd_od_io_init(char *devname, nasd_od_config_t *config);

#endif /* !_NASD__NASD_GENERIC_DRIVE_H_ */

/* Local Variables:  */
/* indent-tabs-mode: nil */
/* tab-width: 2 */
/* End: */
