/*
 * nasd_cheops_mgr_bsimap.h
 */
/*
 * Byte-segment inode definition
 *
 */
/*
 * Copyright (c) 1996,1997,1998,1999 Carnegie Mellon University.
 * All rights reserved.
 *
 * Author: Khalil Amiri, CMU SCS/ECE, July 18 1997
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon the
 * rights to redistribute these changes.
 */

/*
 * 
 */
#ifndef  _NASD_CHEOPS_MGR_STRUCTS_H_
#define  _NASD_CHEOPS_MGR_STRUCTS_H_

#include <nasd/nasd_types.h>
#include <nasd/nasd_mem.h>
#include <nasd/nasd_threadstuff.h>
#include <nasd/nasd_cheops_types.h>
#include <nasd/nasd_cheops_common.h>

#define NASD_CHEOPS_BSINODE_USED       (1<<0) /* inode is used */
#define NASD_CHEOPS_BSINODE_REMOVED    (1<<1) /* object this inode is pointing to has been removed */
#define NASD_CHEOPS_BSINODE_FREE       (1<<2) /* inode is free */
#define NASD_CHEOPS_BSINODE_ISMIG      (1<<3) /* object is undergoing migration */
#define NASD_CHEOPS_BSINODE_RECON      (1<<4) /* object is undergoing reconstruction */

typedef struct nasd_cheops_supermap_s {
        nasd_identifier_t        lastID;
} nasd_cheops_supermap_t;

typedef struct nasd_cheops_bs_inode_s {
	int		      flags;
        nasd_identifier_t     bsg_id;
        nasd_identifier_t     bsid;
        nasd_cookie_t         create_cookie;
	_NASD_CHEOPS_raid_level_t     raid_level;
        int                   num_col;
        int                   num_data_col;
        int                   stripe_unit_size;
        nasd_disk_ident_t     drive_id[_NASD_CHEOPS_MAX_STRIPE_SIZE];
        nasd_identifier_t     object_id[_NASD_CHEOPS_MAX_STRIPE_SIZE];       
} nasd_cheops_bs_inode_t;

        /* cheops drive info structure: local to manager */
	typedef struct nasd_cheops_dinfo_s {
	  nasd_drive_handle_t  h;
	  nasd_disk_ident_t    dr_id;
	  char		       dr_name[_NASD_CHEOPS_DR_NAMELEN];
	  char		       dr_port[_NASD_CHEOPS_DR_NAMELEN];
	  nasd_partnum_t       partnum;
	  long		       used_capacity;
	  long		       max_capacity;
	} nasd_cheops_dinfo_t;

typedef struct nasd_cheops_dmap_s {
	int		      num_drives;
	int		      lastID; 
	nasd_cheops_dinfo_t   dinfo[MAX_NUM_DRIVES];	
} nasd_cheops_dmap_t;

#endif /* NASD_CHEOPS_MGR_STRUCTS_H_  */








