/*
 * nasd_idl_types.h
 */
/*
 * Copyright (c) 1996,1997,1998,1999 Carnegie-Mellon University.
 * All rights reserved.
 *
 * Author: Erik Riedel
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon the
 * rights to redistribute these changes.
 */

/*
 * This file defines the basic system types for USC code generation
 */

/*
 * these MUST match the actual IDL types or the automatically generated
 * marshalling code will be incorrect
 * 
 */

#if (defined(DEC) || defined(DEC_OSF)) && !defined(WIN32)

#define ndr_boolean        unsigned char
#define ndr_false          false
#define ndr_true           true
#define ndr_byte           unsigned char
#define ndr_char           unsigned char
#define ndr_int            int
#define ndr_uint           unsigned int
#define ndr_small_int      signed char
#define ndr_short_int      short int
#define ndr_long_int       int
#define ndr_usmall_int     unsigned char
#define ndr_ushort_int     unsigned short int
#define ndr_ulong_int      unsigned int
struct ndr_uhyper_int_rep   {ndr_ulong_int  low; ndr_ulong_int high;};
struct ndr_hyper_int_rep   {ndr_ulong_int low; ndr_long_int high;};
#ifdef __VMS
#define ndr_uhyper_int     unsigned __int64
#define ndr_hyper_int      signed __int64
#else
#define ndr_uhyper_int     unsigned long int
#define ndr_hyper_int      long int
#endif /* __VMS */

#else /* (DEC || DEC_OSF) && !WIN32 */

#if defined(sparc)

/* from /usr/include/dce/ndrtypes.h on Solaris 2.0 (Transarc DCE 2.1) */
 
typedef unsigned char           ndr_boolean ;
typedef unsigned char           ndr_byte ;
typedef unsigned char           ndr_char ;
typedef signed char             ndr_small_int ;
typedef unsigned char           ndr_usmall_int ;
typedef short int               ndr_short_int ;
typedef unsigned short int      ndr_ushort_int ;
typedef long int                ndr_long_int ;
typedef unsigned long int       ndr_ulong_int ;
struct ndr_hyper_int_rep_s_t {
    ndr_long_int high;
    ndr_ulong_int low;
};
typedef struct ndr_hyper_int_rep_s_t ndr_hyper_int ;
struct ndr_uhyper_int_rep_s_t  {
    ndr_ulong_int high;
    ndr_ulong_int low;
};
typedef struct ndr_uhyper_int_rep_s_t           ndr_uhyper_int ;

#else /* sparc */

#if defined(i386) || defined(LINUX_I386)

/* from /usr/pdl/include/dce/ndrtypes.h on Linux (Linux DCE 1.1) */

#if 0
typedef unsigned char 		ndr_boolean ;
#define ndr_false       false
#define ndr_true        true
typedef unsigned char 		ndr_byte ;
typedef unsigned char 		ndr_char ;
typedef signed char 		ndr_small_int ;
typedef unsigned char 		ndr_usmall_int ;
typedef short int 		ndr_short_int ;
typedef unsigned short int	ndr_ushort_int ;
typedef int 			ndr_long_int ;
typedef unsigned int 		ndr_ulong_int ;
struct ndr_hyper_int_rep_s_t {
    ndr_ulong_int low; 
    ndr_long_int high;
};
struct ndr_uhyper_int_rep_s_t  {
    ndr_ulong_int low; 
    ndr_ulong_int high;
};
typedef long long int		usitll;
typedef unsigned long long int	unusitll;
typedef usitll			ndr_hyper_int ;
typedef unusitll		ndr_uhyper_int ;
#else

#define ndr_boolean        unsigned char
#define ndr_false          false
#define ndr_true           true
#define ndr_byte           unsigned char
#define ndr_char           unsigned char
#define ndr_int            int
#define ndr_uint           unsigned int
#define ndr_small_int      signed char
#define ndr_short_int      short int
#define ndr_long_int       long
#define ndr_usmall_int     unsigned char
#define ndr_ushort_int     unsigned short int
#define ndr_ulong_int      unsigned long
struct ndr_uhyper_int_rep   {ndr_ulong_int  low; ndr_ulong_int high;};
struct ndr_hyper_int_rep   {ndr_ulong_int low; ndr_long_int high;};
#define ndr_uhyper_int     unusitll
#define ndr_hyper_int      usitll

#endif

#endif /* i386 || LINUX_I386 */
#endif /* sparc */
#endif /* (DEC || DEC_OSF) && !WIN32 */

typedef ndr_boolean             idl_boolean ;
typedef ndr_byte                idl_byte ;
typedef char                    idl_char ;
typedef ndr_small_int           idl_small_int ;
typedef ndr_usmall_int          idl_usmall_int ;
typedef ndr_short_int           idl_short_int ;
typedef ndr_ushort_int          idl_ushort_int ;
typedef ndr_long_int            idl_long_int ;
typedef ndr_ulong_int           idl_ulong_int ;
typedef ndr_hyper_int           idl_hyper_int ;
typedef ndr_uhyper_int          idl_uhyper_int ;
typedef ndr_ulong_int           idl_size_t;

