/*
 * Copyright (c) 1997,1998,1999 Carnegie Mellon University.
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon the
 * rights to redistribute these changes.
 */

/***********************************************************************
 *
 * nasd_marshall.h
 *
 * Prototypes for the routines in common/nasd_common_marshall.c
 *
 ***********************************************************************/

#include <nasd/nasd_options.h>
#include <nasd/nasd_types.h>
#include <nasd/nasd_nfs_types.h>
#include <nasd/nasd_drive_types.h>
#include <nasd/nasd_control.h>

#define NASD_M(_f_) \
  void nasd_##_f_##_marshall(nasd_##_f_##_t *in, \
   nasd_##_f_##_otw_t out); \
 void nasd_##_f_##_unmarshall(nasd_##_f_##_otw_t in, \
   nasd_##_f_##_t *out);

#define NASD_M_ARGS(_f_) \
 void nasd_##_f_##_dr_marshall_args(nasd_##_f_##_dr_args_t *in, \
   nasd_##_f_##_dr_args_otw_t out); \
 void nasd_##_f_##_dr_unmarshall_args(nasd_##_f_##_dr_args_otw_t in, \
   nasd_##_f_##_dr_args_t *out);

#define NASD_M_RES(_f_) \
 void nasd_##_f_##_dr_marshall_res(nasd_##_f_##_dr_res_t *in, \
   nasd_##_f_##_dr_res_otw_t out); \
 void nasd_##_f_##_dr_unmarshall_res(nasd_##_f_##_dr_res_otw_t in, \
   nasd_##_f_##_dr_res_t *out);

#define NASD_M_NFS_ARGS(_f_) \
 void nasd_##_f_##_marshall_args(nasd_##_f_##_args_t *in, \
   nasd_##_f_##_args_otw_t out); \
 void nasd_##_f_##_unmarshall_args(nasd_##_f_##_args_otw_t in, \
   nasd_##_f_##_args_t *out);

#define NASD_M_NFS_RES(_f_) \
 void nasd_##_f_##_marshall_res(nasd_##_f_##_res_t *in, \
   nasd_##_f_##_res_otw_t out); \
 void nasd_##_f_##_unmarshall_res(nasd_##_f_##_res_otw_t in, \
   nasd_##_f_##_res_t *out);

#define NASD_M_CTRL(_f_) \
 void nasd_##_f_##_marshall_ctrl(nasd_ctrl_##_f_##_t *in, \
   nasd_ctrl_##_f_##_otw_t out); \
 void nasd_##_f_##_unmarshall_ctrl(nasd_ctrl_##_f_##_otw_t in, \
   nasd_ctrl_##_f_##_t *out);

NASD_M_ARGS(p_part_creat)
NASD_M_RES(p_part_creat)

NASD_M_ARGS(p_create)
NASD_M_RES(p_create)

NASD_M_ARGS(p_getattr)
NASD_M_RES(p_getattr)

NASD_M_ARGS(p_setattr)
NASD_M_RES(p_setattr)

NASD_M_ARGS(p_smpl_op)
NASD_M_ARGS(p_thrtl_op)

NASD_M_RES(p_fastread)

NASD_M_RES(p_fastwrite)

NASD_M_ARGS(p_flush_obj)
NASD_M_RES(p_flush_obj)

NASD_M_ARGS(p_eject_obj)
NASD_M_RES(p_eject_obj)

NASD_M_ARGS(p_remove)
NASD_M_RES(p_remove)

NASD_M_CTRL(drive_info)
NASD_M_CTRL(part_info)
NASD_M_CTRL(drive_opstats)
NASD_M_CTRL(cache_stat)
NASD_M_CTRL(layout_stat)
NASD_M_CTRL(ioqueue_stat)
NASD_M_CTRL(io_stat)
NASD_M_CTRL(io_size_stat)
NASD_M_CTRL(trace_basic)

NASD_M_ARGS(p_initialize)
NASD_M_RES(p_initialize)

NASD_M_ARGS(p_change_key)
NASD_M_RES(p_change_key)

NASD_M_NFS_ARGS(nfs_lookup)
NASD_M_NFS_RES(nfs_lookup)

NASD_M(trace_header)
