/*
 * nasd_net_convert.h
 *
 * This file defines all the types used in the routines automatically
 * generated from 'include/nasd/nasd_net_covert.usc'.  Whenever you
 * add a routine to that file, you must add the appropriate type here
 *
 * use of this file should be limited to common/nasd_marshall.c
 *
 * all nasd_otw_*_t types can simply be typedefed to nasd_byte
 */
/*
 * Copyright (c) 1996,1997,1998,1999 Carnegie-Mellon University.
 * All rights reserved.
 *
 * Author: Erik Riedel
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon the
 * rights to redistribute these changes.
 */

/* Universal Stub Compiler for NASD - net types */

typedef nasd_byte nasd_otw_cookie_t;
typedef nasd_byte nasd_otw_attribute_t;

/* Basic Types */

typedef nasd_byte nasd_otw_read_dr_args_t;
typedef nasd_byte nasd_otw_read_dr_res_t;
typedef nasd_byte nasd_otw_file_io_list_t;
typedef nasd_byte nasd_otw_write_dr_args_t;
typedef nasd_byte nasd_otw_write_dr_res_t;

typedef nasd_byte nasd_otw_av_t;
typedef nasd_byte nasd_otw_key_t;
typedef nasd_byte nasd_otw_timespec_t;
typedef nasd_byte nasd_otw_status_t;
typedef nasd_byte nasd_otw_security_param_t;
typedef nasd_byte nasd_otw_capability_args_t;
typedef nasd_byte nasd_otw_ctrl_drive_info_t;
typedef nasd_byte nasd_otw_ctrl_part_info_t;
typedef nasd_byte nasd_otw_ctrl_drive_opstats_t;
typedef nasd_byte nasd_otw_ctrl_cache_stat_t;
typedef nasd_byte nasd_otw_ctrl_layout_stat_t;
typedef nasd_byte nasd_otw_ctrl_ioqueue_stat_t;
typedef nasd_byte nasd_otw_ctrl_io_stat_t;
typedef nasd_byte nasd_otw_ctrl_io_size_stat_t;
typedef nasd_byte nasd_otw_ctrl_trace_basic_t;

/* RPC arg/res structures */

typedef nasd_byte nasd_otw_p_getattr_dr_res_t;
typedef nasd_byte nasd_otw_p_getattr_dr_args_t;

typedef nasd_byte nasd_otw_p_setattr_dr_args_t;
typedef nasd_byte nasd_otw_p_setattr_dr_res_t;

typedef nasd_byte nasd_otw_p_create_dr_args_t;
typedef nasd_byte nasd_otw_p_create_dr_res_t;


typedef nasd_byte nasd_otw_p_part_creat_dr_args_t;
typedef nasd_byte nasd_otw_p_part_creat_dr_res_t;

typedef nasd_byte nasd_otw_p_smpl_op_dr_args_t;
typedef nasd_byte nasd_otw_p_thrtl_op_dr_args_t;

typedef nasd_byte nasd_otw_p_fastread_dr_args_t;
typedef nasd_byte nasd_otw_p_fastread_dr_res_t;

typedef nasd_byte nasd_otw_p_fastwrite_dr_args_t;
typedef nasd_byte nasd_otw_p_fastwrite_dr_res_t;

typedef nasd_byte nasd_otw_p_flush_obj_dr_args_t;
typedef nasd_byte nasd_otw_p_flush_obj_dr_res_t;

typedef nasd_byte nasd_otw_p_eject_obj_dr_args_t;
typedef nasd_byte nasd_otw_p_eject_obj_dr_res_t;

typedef nasd_byte nasd_otw_p_remove_dr_args_t;
typedef nasd_byte nasd_otw_p_remove_dr_res_t;


typedef nasd_byte nasd_otw_p_initialize_dr_args_t;
typedef nasd_byte nasd_otw_p_initialize_dr_res_t;



typedef nasd_byte nasd_otw_p_change_key_dr_args_t;
typedef nasd_byte nasd_otw_p_change_key_dr_res_t;


typedef nasd_byte nasd_otw_nfs_lookup_args_t;
typedef nasd_byte nasd_otw_nfs_lookup_res_t;

typedef nasd_byte nasd_otw_trace_header_t;
