/*
 * nasd_security_types.h
 */
/*
 * Copyright (c) 1997,1998,1999 Carnegie Mellon University.
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon the
 * rights to redistribute these changes.
 */

/***********************************************************************
 *
 * nasd_security_types.h
 *
 * Put the Security in NASD!
 *
 ***********************************************************************/
#ifndef _NASD_SECURITY_TYYPES_
#define _NASD_SECURITY_TYYPES_

#include <nasd/nasd_options.h>
#include <nasd/nasd_types.h>
#include <cryptolib/libcrypt.h>

typedef struct nasd_security_context_s {
  HMAC_SHA1_CTX HMAC_context;
  SHA_CTX SHA1_ctx;
  nasd_uint16 protection;
  nasd_uint16 started;
  nasd_offset_t curr_off;
  nasd_offset_t start_off;
} nasd_security_context_t;


typedef struct nasd_security_cache_el_s {
  nasd_capability_args_t cap_args;
  nasd_key_t the_key; 
  struct nasd_security_cache_el_s *next;
  nasd_int32 id;
} nasd_security_cache_el_t; 

#endif /* ! _NASD_SECURITY_TYPES__ */





