/*
 * nasd_trace.h
 *
 * Shared structures and defs for NASD tracing.
 */
/*
 * Copyright (c) 1998,1999 Carnegie-Mellon University.
 * All rights reserved.
 *
 * Author: Jim Zelenka
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon the
 * rights to redistribute these changes.
 */


#ifndef _NASD_TRACE_H_
#define _NASD_TRACE_H_

#include <nasd/nasd_options.h>
#include <nasd/nasd_base_types.h>
#include <nasd/nasd_types.h>

/*
 * Trace classes
 */
#define NASD_TR_TRACE       (1<<00)
#define NASD_TR_ARG         (1<<01)
#define NASD_TR_RES         (1<<02)

/*
 * TRACE traces
 */
#define NASD_TR_OVERFLOW       1

/*
 * ARGS and RES traces
 */
#define NASD_TR_NOOP           1
#define NASD_TR_CREATE         2
#define NASD_TR_GETATTR        3
#define NASD_TR_READ_SIMPLE    4
#define NASD_TR_WRITE_SIMPLE   5
#define NASD_TR_SETATTR        6
#define NASD_TR_FLUSH          7
#define NASD_TR_REMOVE         8
#define NASD_TR_EJECT          9
#define NASD_TR_SYNC          10
#define NASD_TR_PART_CREAT    11

#endif /* !_NASD_TRACE_H_ */
