/*
 * nasd_varargs.h
 *
 * Definitions for varargs in NASD
 */
/*
 * Copyright (c) 1999 Carnegie-Mellon University.
 * All rights reserved.
 *
 * Author: Jim Zelenka
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon the
 * rights to redistribute these changes.
 */

#ifndef _NASD__NASD_VARARGS_H_
#define _NASD__NASD_VARARGS_H_

#if NASD_USE_OLD_VARARGS > 0
#include <varargs.h>

#define NASD_VARARGS_PROTO(_expr_)

typedef va_list nasd_valist_t;

#define NASD_VARARG_START(_valist_,_firstarg_)  va_start(_valist_)
#define NASD_VARARG_END(_valist_)               va_end(_valist_)

#else /* NASD_USE_OLD_VARARGS > 0 */
#include <stdarg.h>

#define NASD_VARARGS_PROTO(_expr_) _expr_

typedef va_list nasd_valist_t;

#define NASD_VARARG_START(_valist_,_firstarg_)  va_start(_valist_,_firstarg_)
#define NASD_VARARG_END(_valist_)               va_end(_valist_)

#endif /* NASD_USE_OLD_VARARGS > 0 */

#endif /* !_NASD__NASD_VARARGS_H_ */

/* Local Variables:  */
/* indent-tabs-mode: nil */
/* tab-width: 2 */
/* End: */
