/*
 *  globals.h -- global variables.
 *
 *  Copyright 1995 by the Arizona Board of Regents.
 *
 *  Permission to use, copy, modify, and distribute this software and its
 *  documentation for any purpose and without fee is hereby granted, provided
 *  that this notice appears in all copies and supporting documentation.
 *  This software is provided "as is", with no warranty.
 */

extern void (*gcode)();			/* code generation algorithm */

extern char *iname;			/* input file name */
extern int iline;			/* current line number */

extern FILE *pfile;			/* prototype output file, if any */
extern int tflag;			/* NZ to preserve types on output */

extern char dbflags[128];		/* debugging flags */

extern Symbol *curfunc;			/* function currently being parsed */

extern Type *chartype;			/* pointer to type struct for "char" */
extern Type *shorttype;			/* pointer to type struct for "short" */
extern Type *inttype;			/* pointer to type struct for "int" */
extern Type *longtype;			/* pointer to type struct for "long" */
#ifndef __alpha
extern Type *hypertype;			/* pointer to type struct for "usitll" */
extern Type *uhypertype;		/* pointer to type struct for "unusitll" */
#endif /* !__alpha */

extern Type *native[MAXINTBYTES+1];	/* best native type of each size */

extern Annot noannot;			/* null annotation struct (all zero) */
