/*
 *  buffer.h
 *
 *  Copyright 1994, 1995 by the Arizona Board of Regents.
 *
 *  Permission to use, copy, modify, and distribute this software and its
 *  documentation for any purpose and without fee is hereby granted, provided
 *  that this notice appears in all copies and supporting documentation.
 *  This software is provided "as is", with no warranty.
 */

#ifndef INBUFFERH
#define INBUFFERH

#define FUNCHEADERBUFFER 1024
#define FUNCBODYBUFFER   1024
#define FUNCVARBUFFER    32

typedef struct {
  char *s;
  int size;
  int length;
} Buffer;

#define BUFFER_STRING(a)    ((a)->s)
#define BUFFER_SIZE(a)      ((a)->size)
#define BUFFER_LEN(a)       ((a)->length)

extern Buffer *SourceText;

extern void writebuf (Buffer *buffer, char *fmt, ...);
extern Buffer *makebuf (int size);
extern void cleanbuf (Buffer *buffer);
extern void freebuf (Buffer *buf);
extern void catbuf (Buffer *one, Buffer *two);
extern void dump_source (void);

#endif
