/*
 *  config.c
 *
 *  Copyright 1994, 1995 by the Arizona Board of Regents.
 *
 *  Permission to use, copy, modify, and distribute this software and its
 *  documentation for any purpose and without fee is hereby granted, provided
 *  that this notice appears in all copies and supporting documentation.
 *  This software is provided "as is", with no warranty.
 */

/*
 * Target compiler "configuration": handles information about basic types
 * in the target compiler based on pragmas.
 */

#include "usc.h"

MachineInfo machine_info = {
  DEFAULT_NUM_REGS,
  DEFAULT_REG_SIZE,
#ifndef __alpha
  {
    DEFAULT_SIZE,
    -1,				/* DEFAULT_LONGLONG_MEMSIZE, */
    DEFAULT_ALIGN,
    DEFAULT_BORDER,		/* DEFAULT_LONGLONG_BYTEORDER */
    "usitll"
  },
  {
    DEFAULT_SIZE,
    -1,				/* DEFAULT_LONGLONG_MEMSIZE, */
    DEFAULT_ALIGN,
    DEFAULT_BORDER,		/* DEFAULT_LONGLONG_BYTEORDER */
    "unusitll"
  },
#endif /* !__alpha */
  {
    DEFAULT_SIZE,
    -1,                       /* DEFAULT_LONG_MEMSIZE,    */
    DEFAULT_ALIGN,
    DEFAULT_BORDER,           /* DEFAULT_LONG_BYTEORDER,  */
    "long"
  },
  {
    DEFAULT_SIZE,
    -1,                       /* DEFAULT_INT_MEMSIZE,     */
    DEFAULT_ALIGN,
    DEFAULT_BORDER,            /* DEFAULT_INT_BYTEORDER,   */
    "int"
  },
  {
    DEFAULT_SIZE,
    -1,                       /* DEFAULT_SHORT_MEMSIZE,   */
    DEFAULT_ALIGN,
    DEFAULT_BORDER,           /* DEFAULT_SHORT_BYTEORDER, */
    "short"
  },
  {
    DEFAULT_SIZE,
    -1,                       /* DEFAULT_CHAR_MEMSIZE,    */
    DEFAULT_ALIGN,
    DEFAULT_BORDER,           /* DEFAULT_CHAR_BYTEORDER,  */
    "char"
  }
};
