/*
 *  config.h
 *
 *  Copyright 1994, 1995 by the Arizona Board of Regents.
 *
 *  Permission to use, copy, modify, and distribute this software and its
 *  documentation for any purpose and without fee is hereby granted, provided
 *  that this notice appears in all copies and supporting documentation.
 *  This software is provided "as is", with no warranty.
 */

typedef struct {
  int size;
  int memsize;
  int alignment;
  ByteOrder byteorder;
  char *name;
} BucketInfo;

typedef struct {
  int num_regs;
  int reg_size;
#ifndef __alpha 
  BucketInfo longlong_info;
  BucketInfo ulonglong_info;
#endif /* !__alpha */
  BucketInfo long_info;
  BucketInfo int_info;
  BucketInfo short_info;
  BucketInfo char_info;
} MachineInfo;

extern MachineInfo machine_info;

#if __alpha
#define MAX_BITFIELD_SIZE (((!machine_info.long_info.size))? \
			   256: (8 * machine_info.long_info.size) )
#else /* __alpha */
#define MAX_BITFIELD_SIZE (((!machine_info.longlong_info.size))? \
			   256: (8 * machine_info.longlong_info.size) )
#endif /* __alpha */

#define MAX_BORDER_SIZE   33

#define DEFAULT_NUM_REGS              8
#define DEFAULT_REG_SIZE              0

#define LOCAL_PREFIX    "l_"
#define RETURN_PREFIX   "r_"

#define DEFAULT_NATIVE_COMPILER "cc"
