/*
 *  error.c
 *
 *  Copyright 1994, 1995 by the Arizona Board of Regents.
 *
 *  Permission to use, copy, modify, and distribute this software and its
 *  documentation for any purpose and without fee is hereby granted, provided
 *  that this notice appears in all copies and supporting documentation.
 *  This software is provided "as is", with no warranty.
 */

#include "usc.h"

int Debug_Level = DEBUGLEVEL;

void crash(char *fmt, ...)
{
  va_list args;

  va_start(args, fmt);
  fprintf (stderr, "fatal error in line %d: ", LineNum);
  vfprintf (stderr, fmt, args);
  fprintf (stderr, "\n");

  va_end (args);
  if (/*CONSTCOND*/ TRIGGER_COREDUMP)
    abort();
  else
    exit (1);
}

void error (char *fmt, ...)
{
  va_list args;

  va_start(args, fmt);
  fprintf (stderr, "error in line %d: ", LineNum);
  vfprintf (stderr, fmt, args);
  fprintf (stderr, "\n");
  va_end (args);
}

void warning (char *fmt, ...)
{
  va_list args;

  va_start(args, fmt);
  fprintf (stderr, "warning: line %d: ", LineNum);
  vfprintf (stderr, fmt, args);
  fprintf (stderr, "\n");
  va_end (args);
}
