/*
 *  hash.h -- header file which prototypes all hash functions.
 *
 *  Copyright 1994, 1995 by the Arizona Board of Regents.
 *
 *  Permission to use, copy, modify, and distribute this software and its
 *  documentation for any purpose and without fee is hereby granted, provided
 *  that this notice appears in all copies and supporting documentation.
 *  This software is provided "as is", with no warranty.
 */

#ifndef INHASHH
#define INHASHH

typedef struct bucket {
  struct bucket *next;
  struct bucket **prev;
} Bucket;

typedef struct hash_tab_ {
  int size;
  int numsyms;
  unsigned (*hash)();
  int (*cmp)();
  Bucket *table[1];
} Hash_Tab;

extern Hash_Tab *maketab(unsigned maxsym, unsigned (*hash)(), int (*cmp)());
extern void *newsym (int size);
extern void *addsym (Hash_Tab *tabp, void *sym);
extern void *findsym (Hash_Tab *tabp, void *sym);
extern void delsym (Hash_Tab *tabp, void *sym);
extern void cleantab (Hash_Tab *tabp, int (*test)());
extern int  ptab (Hash_Tab *tabp, void (*prnt)(), void *par, int srt);

#endif
