/*
 *  symbol.h
 *
 *  Copyright 1994, 1995 by the Arizona Board of Regents.
 *
 *  Permission to use, copy, modify, and distribute this software and its
 *  documentation for any purpose and without fee is hereby granted, provided
 *  that this notice appears in all copies and supporting documentation.
 *  This software is provided "as is", with no warranty.
 */

extern int NestLevel;

extern void init_symbols(void);

extern void set_to_string (Constant *theconst, char *string);
extern void set_to_int (Constant *theconst, char *string);
extern void set_to_float (Constant *theconst, char *string);

extern void pushlevel (void);
extern void poplevel (void);

extern Symbol *ident_to_sym (char *theident);
extern Symbol *cat_sym (Symbol *one, Symbol *two);
extern Type *make_specifier (Constant *theconst);
extern Type *or_specifier (Type *one, Type *two);
extern Symbol *distribute_specifier (Type *thetype, Symbol *symlist);
extern Type *find_struct_def (char *name);
extern Type *finish_struct_def (Type *spec, char *name, Symbol *syms);
extern Type *add_to_struct_defs (Type *stdef, int level);
extern Type *make_typedef (Type *thetype);
extern Symbol *add_to_sym_or_type_table (Symbol *syms);
extern Type *find_type (char *name);
extern Symbol *make_array (Symbol *sym, Expr *theexpr);
extern Symbol *make_pointer (Symbol *sym);
extern Symbol *make_function (Symbol *sym, Symbol* param_list);
extern void check_and_set_type_data (Symbol *syms);
extern Symbol *find_sym (char *name);
extern void set_all_sym_type_info (Symbol *sym);
extern TypeData *make_default_typedata (void);
extern Type *make_native_bitfield (Expr *theexpr);
extern Symbol *make_bitfield (Symbol *decl, Type *bitfield);
extern Type *copy_type(Type *thetype);
extern char *local_name( char* name );
extern char *return_name( char* name );
extern void variable_length_array( Type* var_len_type, VarLen* var_len_data );
extern Expr *sizeof_type( Type* type );
extern char *spec_type_to_string (Type* type);
