/*
 *  utils.h
 *
 *  Copyright 1994, 1995 by the Arizona Board of Regents.
 *
 *  Permission to use, copy, modify, and distribute this software and its
 *  documentation for any purpose and without fee is hereby granted, provided
 *  that this notice appears in all copies and supporting documentation.
 *  This software is provided "as is", with no warranty.
 */

#include "buffer.h"

#ifndef INGEN_UTILH
#define INGEN_UTILH

typedef struct code_level {
  Buffer *func_body;
  Buffer *vars;
  Buffer *body1;
  Buffer *body2;
  Buffer *body3;
  Buffer *body4;
  Buffer *body5;
  struct code_level *next;
} CodeLevel;

typedef struct namelist {
  char *name;
  struct namelist *next;
} NameList;

typedef enum { NORMAL_PARAM, BYTEVOID_PARAM, CASTVOID_PARAM } ParamFlag;

typedef enum { USC_OUTPUT, USIT_OUTPUT, USC_TYPES } OutputType;

extern Buffer *func_header;
extern Buffer *vars, *body1, *body2, *body3, *body4, *body5;
extern int code_stack_depth;


extern void genout (char *fmt, ...);
extern void gen_func_name_header (char *type, char *ident);
extern void gen_func_close (void);
extern void push_code_level (void);
extern void pop_code_level (void);
extern void init_gen_utils (FILE *out);
extern void init_outfile (OutputType output_type);
extern void dont_deref (char *name);
extern int do_i_deref (char *name);
extern void genbuf (Buffer *buffer);
extern void write_eol (Buffer *buf);
extern int pos_to_bit (ByteOrder order, int pos);

#endif
